package ch.epfl.tpp;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

public class ConcreteInvertedIndex implements InvertedIndex {
    private final Map<String, Set<Document>> index = new HashMap<>();
    private final Set<Document> emptyDocSet = new HashSet<>();
    
    @Override
    public void addDocument(Document d) {
        Iterator<String> it = d.wordsIterator();
        while (it.hasNext()) {
            String w = it.next();
            if (! index.containsKey(w))
                index.put(w, new HashSet<Document>());
            index.get(w).add(d);
        }
    }
    
    @Override
    public Set<Document> documentsWithWord(String word) {
        return index.containsKey(word) ? index.get(word) : emptyDocSet;
    }
}
